<?php
/*******************************************************************************/
//                          InstantCMS v1.10.3                                 //
//                      http://www.instantcms.ru/                              //                                                   
//                  плагин "Похожие фотографии" v.1.0.0                        //
//                        (p_rel_photos)                                       //
//                     written by Marat Fatikhov                               //
//                      (nickname Марат on a site)                             //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/
class p_rel_photos extends cmsPlugin {

//=============================================================================//


public function __construct(){

        parent::__construct();

        // Информация о плагине

        $this->info['plugin']           = 'p_rel_photos';
        $this->info['title']            = 'Похожие фотографии';
        $this->info['description']      = 'Выводит похожие фотографии на странице просмотра фото';
        $this->info['author']           = 'Marat Fatikhov';
        $this->info['version']          = '1.0.0';        

        // Настройки по-умолчанию
        $this->config['Количество выводимых фото'] = 5;
        $this->config['Автопроигрывание, 0-нет, 1-да'] = 0;
        
        // События, которые будут отлавливаться плагином

        $this->events[]                 = 'GET_PHOTO';       
    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install(){        

        return parent::install();

    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){               
         
        return parent::upgrade();

    }

// ==================================================================== //

     /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();

        switch ($event){
            case 'GET_PHOTO': $item = $this->getRelPhotos($item); break;            
        }

        return $item;

    }
    
    // ==================================================================== //
     private function getRelPhotos($photo){
         
         $inDB = cmsDatabase::getInstance();
         
         $limit = $this->config['Количество выводимых фото'];
         $limit = ($limit != 0) ? (int)$limit : 5;
         
         $photo['more'] = '';         
         
         //выборка из базы данных
         $sql = "SELECT id, title, file
                FROM `cms_photo_files`
                WHERE id != '{$photo['id']}' AND 
                (owner = 'photos' OR  owner = '') AND            
                MATCH(title, description) AGAINST('{$photo['title']} {$photo['description']}')                
                LIMIT {$limit}";
            
          $rs = $inDB->query($sql);
          if(!$inDB->num_rows($rs)){//если похожих фото нет, выбираем фото из того же альбома 
                 $sql = "SELECT id, title, file
                FROM `cms_photo_files`
                WHERE id != '{$photo['id']}' AND 
                (owner = 'photos' OR  owner = '') AND
                album_id = '{$photo['album_id']}'
                ORDER BY `id` DESC    
                LIMIT {$limit}";
                
                $rs = $inDB->query($sql);
              }
              
         if(!$inDB->num_rows($rs)){ return $photo; }     
            
          $rel_photos = array();
          while ($item = $inDB->fetch_assoc($rs)){              
              $rel_photos[] = $item; 
          }          
          ob_start();
          
          $smarty= $this->inCore->initSmarty('plugins', 'p_relphotos.tpl');
          $smarty->assign('rel_photos', $rel_photos);
          $smarty->assign('autoplay', $this->config['Автопроигрывание, 0-нет, 1-да']);
          $smarty->display('p_relphotos.tpl');
          
          $photo['more'] = ob_get_clean();                        
          return $photo;    
     }
    // ==================================================================== //     
     
}//class
?>
